#include "opendrive_road.h"
#include "exceptions.h"
#include <iostream>
#include <vector>
#include <limits>

int main(int argc, char *argv[])
{
//  TOpendriveWorldPose closest_pose;
  std::vector<double> x,y;
  COpendriveRoad road,new_road;
  std::vector<unsigned int> path;
  TOpendriveWorldPose end_pose,start_pose;
  std::string xml_file="/home/sergi/iri-lab/adc_ws/code/autonomous_driving_tools/src/xml/add_road_full.xodr";
//  std::string xml_file="/home/sergi/iri-lab/adc_ws/code/autonomous_driving_tools/src/xml/adc_road.xodr";
  
  try
  {
    road.set_resolution(0.01);
    road.set_scale_factor(10.0);
    road.set_min_road_length(0.01);
    road.load(xml_file);
//    std::cout << road << std::endl;
    for(unsigned int i=0;i<road.get_num_nodes();i++)
    {
      const COpendriveRoadNode &node=road.get_node(i);
      for(unsigned int j=0;j<node.get_num_links();j++)
      {
        const COpendriveLink &link=node.get_link(j);
        link.get_trajectory(x,y);
        for(unsigned int k=0;k<x.size();k++)
          std::cout << x[k] << "," << y[k] << std::endl;
      }
    }
/*
    path.push_back(4);
    start_pose.x=10.0;
    start_pose.y=0.0;
    start_pose.heading=0.0;
    end_pose.x=17.0;
    end_pose.y=0.0;
    end_pose.heading=0.0;
    road.get_sub_road(path,start_pose,end_pose,new_road);
    std::cout << "road1" << std::endl;
    std::cout << new_road << std::endl;
*/
/*
    path.clear();
    path.push_back(4);
    path.push_back(6);
    path.push_back(8);
    path.push_back(150);
    path.push_back(67);
    path.push_back(69);
    path.push_back(71);
    start_pose.x=10.0;
    start_pose.y=0.0;
    start_pose.heading=0.0;
    end_pose.x=18.5;
    end_pose.y=22.0;
    end_pose.heading=0.0;
    road.get_sub_road(path,start_pose,end_pose,new_road);
//    std::cout << "road2" << std::endl;
//    std::cout << new_road << std::endl;
    for(unsigned int i=0;i<new_road.get_num_nodes();i++)
    {
      const COpendriveRoadNode &node=new_road.get_node(i);
      for(unsigned int j=0;j<node.get_num_links();j++)
      {
        const COpendriveLink &link=node.get_link(j);
        link.get_trajectory(x,y);
        for(unsigned int k=0;k<x.size();k++)
          std::cout << x[k] << "," << y[k] << std::endl;
      }
    }
*/
/*
    if(argc!=4)
    {
      std::cout << "Invalid number of parameters" << std::endl;
      std::cout << argv[0] << " x y heading" << std::endl;
      return -1;
    }
    end_pose.x=std::stod(argv[1]);
    end_pose.y=std::stod(argv[2]);
    end_pose.heading=std::stod(argv[3]);
    length=road.get_closest_pose(end_pose,closest_pose);
    std::cout << "closest pose to: " << x << "," << y << "," << heading << " -> " << closest_pose.x << "," << closest_pose.y << "," << closest_pose.heading << " at " << length << " m" << std::endl;
*/  
/*
    path.push_back(0);
    start_pose.x=1.0;
    start_pose.y=0.0;
    start_pose.heading=0.0;
    end_pose.x=2.0;
    end_pose.y=0.0;
    end_pose.heading=0.0;
    road.get_sub_road(path,start_pose,end_pose,new_road);
    std::cout << "road1" << std::endl;
    std::cout << new_road << std::endl;
*/
/*
    path.clear();
    path.push_back(0);
    path.push_back(22);
    path.push_back(2);
    start_pose.x=1.0;
    start_pose.y=0.0;
    start_pose.heading=0.0;
    end_pose.x=5.0;
    end_pose.y=0.0;
    end_pose.heading=0.0;
    road.get_sub_road(path,start_pose,end_pose,new_road);
    std::cout << "road2" << std::endl;
    std::cout << new_road << std::endl;
    path.clear();
    path.push_back(0);
    path.push_back(22);
    path.push_back(2);
    path.push_back(4);
    path.push_back(6);
    path.push_back(8);
    path.push_back(10);
    path.push_back(25);
    path.push_back(21);
    path.push_back(24);
    path.push_back(1);
    start_pose.x=1.0;
    start_pose.y=0.0;
    start_pose.heading=0.0;
    end_pose.x=2.0;
    end_pose.y=0.0;
    end_pose.heading=0.0;
    road.get_sub_road(path,start_pose,end_pose,new_road);
    std::cout << "road3" << std::endl;
    std::cout << new_road << std::endl;
*/
/*
    for(unsigned int i=0;i<new_road.get_num_nodes();i++)
    {
      const COpendriveRoadNode &node=new_road.get_node(i);
      for(unsigned int j=0;j<node.get_num_links();j++)
      {
        const COpendriveLink &link=node.get_link(j);
        link.get_trajectory(x,y);
        for(unsigned int k=0;k<x.size();k++)
          std::cout << x[k] << "," << y[k] << std::endl;
      }
    }
*/
  }
  catch (CException &e)
  {
    std::cout << "[Exception caught] : " << e.what() << std::endl;
  }
  return 0;
}
